(define-module (ui netinst ajax)
    :use-module (alterator woo)
    :use-module (alterator ajax)
    :use-module (alterator effect)
    :export (init))

(define (ui-list)
  (form-update-enum "image" (woo-list "/netinst" 'language (form-value "language"))))

(define (ui-read)
  (catch/message
    (lambda()
      (form-update-value-list
	'("name" "url" "image")
	(woo-read-first "/netinst")))))

(define (ui-select)
  (catch/message
    (lambda()
      (woo-write "/netinst"
		 'sel #t
		 'image (form-value "image")
		 'language (form-value "language"))
      (ui-read)
      (update-effect))))

(define (ui-delete)
  (catch/message
    (lambda()
      (if (form-confirm (_ "Are you really want to remove image?") (_ "Question") (_ "Yes") (_ "No"))
	(begin
	  (woo-write "/netinst"
		     'del #t
		     'image (form-value "image")
		     'language (form-value "language"))
	  (ui-list)
	  (ui-read)
	  (update-effect))))))

(define (ui-add)
  (catch/message
    (lambda()
      (woo-write "/netinst"
		 'add #t
		 'get_from (form-value "get_from")
		 'add_url (form-value "add_url")
		 'language (form-value "language"))
      (form-replace "/netinst/wait"))))

(define (init)
  (ui-list)
  (ui-read)

  (effect-disable "del_button" "image" "0")
  (effect-hide "url_box" "name" "")
  (effect-enable "add_url" "get_from" "url")
  (init-effect)

  (form-bind "sel_button" "click" ui-select)
  (form-bind "del_button" "click" ui-delete)
  (form-bind "add_button" "click" ui-add))
